#ifndef __GTK_PAPER_TAPE_H__
#define __GTK_PAPER_TAPE_H__

#include "gtkmm/box.h"
#include "gtk/gtk.h"
#include <gtkmm/uimanager.h>
#include <gtkmm/dialog.h>

// predefine for usage in other header files
namespace Gtk
{ class PaperTape; }
#include "gtkpapertapeview.h"
#include "gtkpapertapefile.h"

typedef unsigned char byte_t;

namespace Gtk {

/**
 * Klasse knnte GtkWidget erweitern und dann selbst das Haupt
 * master drumherumwidget sein, was automatisch richtige Kinder
 * herzaubert, inkl. Scrolling und beispielsweise greaterzoom-ding.
 * Oder dann das IO teil, usw.
 *
 **/
class PaperTape : public VBox
{
	
public:
	PaperTapeView* view;
	PaperTapeFile* model;
	Window* parent_window;
	
private:
	
	static Glib::ustring ui_info;
	static GtkActionEntry ui_common_entries[];
	static GtkActionEntry ui_file_entries[];
	static GtkActionEntry ui_editor_entries[];
	static GtkToggleActionEntry ui_toggle_entries[];
	Glib::RefPtr<Gtk::UIManager> ui_manager;
	void make_menu();
	void menu_actions(const Glib::RefPtr<Action>& action);

public:
	PaperTape(Window& parent_window);
	
	/**
	 * Runs the dialog. This is just like dialog.run(),
	 * but with the correct parent window (modal dialog),
	 * which is saved in this widget.
	 **/
	int run_dialog(Dialog& dialog) {
		dialog.set_transient_for(*this->parent_window);
		return dialog.run();
	}

	/**
	 * Open a blank file. This will ask if user wants to close
	 * file and open, if yes, a new blank file.
	 **/
	//void new_file();
	/**
	 * Show a file dialog to open an existing file. This will
	 * ask the user if he wants to close the current file.
	 **/
	//void open_file();
	/**
	 * Ask the user if he wants to close the current file. If so,
	 * close it, leaving with no file opened (splash screen)
	 **/
	//void close_file();
	/**
	 * Check if a file is opened.
	 * @returns true if a file is opened.
	 **/
	//boolean file_is_open();
};


}; // namespace Gtk
#endif // __GTK_PAPER_TAPE_H__
