#ifndef __GTK_PAPER_TAPE_EXPORTERL_H__
#define __GTK_PAPER_TAPE_EXPORTERL_H__

#include <gtkmm/filechooser.h>
#include <gtkmm/filechooserdialog.h>


#include <gtkmm/button.h>
#include <gtkmm/viewport.h>
#include <gtkmm/adjustment.h>
#include <gtkmm/expander.h>
#include <gtkmm/radiobutton.h>
#include <gtkmm/radiobuttongroup.h>
#include <gtkmm/progressbar.h>
#include <gtkmm/main.h>


namespace Gtk
{ class PaperTapeExporter; }
#include "lochstreifen.h"
#include "gtkpapertape.h"

namespace Gtk {

enum PaperTapeExporterType {
	SVG,
	PNG
};

class PaperTapeExporter : public FileChooserDialog {
	//Window* parent;
	LOCHSTREIFEN* l;
	
	static void update_gui(const row_t* current_row, cairo_t* context, void* user_data);

	Button* cancel_button;
	ProgressBar progress;
	VBox extra_widget;
	bool cancel_export;
	
	RadioButton type_auto_select;
	RadioButton type_svg;
	RadioButton type_png;
	
public:
	PaperTapeFile* file;
	LOCHSTREIFEN* lochstreifen;
	
	PaperTapeExporter(PaperTapeView& view);
	PaperTapeExporter(Window& parent, const LOCHSTREIFEN* l);
	bool run_export();
	void cancel();
};

} // namespace Gtk

#endif // EXPORTER_H
